#!/usr/bin/ruby -w
#
#
# Distributed password cracker 
# 
# Copyright 2008 Raboin Romain - romain.raboin at gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#


require 'resolv'
require 'getoptlong'
require 'net/https'
require 'uri'
require 'digest/md5'
require 'timeout'

HOST	= "localhost"		# default server hostname
PORT	= 8080			# default password port
METHOD	= "markov"		# default john method
JOHN	= "./myjohn/run/john"	# default john PATH


# HttpPost
# - Ask for new job
# - POST password found
class	HttpPost
	# Ask for new job
	def NewJob(host, port, passwd, myid, method)
		url = URI.parse("https://#{host}/newjob")
		url.port = port
		req = Net::HTTP::Post.new(url.path)
		if myid == 0
			host = `hostname`
			req.set_form_data({'passwd'=>passwd, 'id'=>myid, 'method'=>method, 'host'=>host.chomp}, ';')
		else
			req.set_form_data({'passwd'=>passwd, 'id'=>myid, 'method'=>method}, ';')
		end
		begin		
			https = Net::HTTP.new(url.host, url.port)
			https.use_ssl = true
			https.verify_mode = OpenSSL::SSL::VERIFY_NONE
			https.read_timeout = 500
			res = https.start {|http| http.request(req) }
			return res.body
		rescue
			puts "[!] Unable to connect to server: " + $!
			cleantmpfile	
			exit
		end
	end

	# Post password found
	def	NewHash(host, port, passwd, myid, hash)
		tab = hash.split(/([^ ]+) +\(([^\)]+)\)$/)
		url = URI.parse("https://#{host}/newhash")
		url.port = port
		req = Net::HTTP::Post.new(url.path)
		req.set_form_data({'passwd'=>passwd, 'id'=>myid, 'hash'=>"#{tab[1]}:#{tab[2]}"}, ';')

		begin
			https = Net::HTTP.new(url.host, url.port)
			https.use_ssl = true
			https.verify_mode = OpenSSL::SSL::VERIFY_NONE
			res = https.start {|http| http.request(req) }
			return res.body
		rescue
			puts "[!] Unable to connect to server: " + $!
			cleantmpfile
			exit
		end
	end
end


def	help
	puts "Usage: #{$0} [options]"
	puts "\t-h --help\t\tthis help."
	puts "\t-i --host\t\tserver host name. [#{HOST}]"
	puts "\t-P --port\t\tport. [#{PORT}]"	
	puts "\t-p --password\t\tpassword for this session."	
	puts "\t-j --john\t\tjohn path. [#{JOHN}]"
	puts "\t-f --format\t\tforce ciphertext format."
	puts "\nExample:\n"
	puts "#{$0} -i server.org -P 8080 -p password -j /home/romain/myjohn/john"	
	exit
end



host 	= HOST		# server hostname
port 	= PORT		# server port
passwd 	= nil		# server password
tformat	= nil		# cipher text format 
method 	= METHOD	# john method : markov or incremental
johnpath = JOHN		# john path

opts = GetoptLong.new(
	[ '--help', '-h', GetoptLong::NO_ARGUMENT ],
	[ '--host', '-i', GetoptLong::REQUIRED_ARGUMENT ],
	[ '--port', '-P', GetoptLong::OPTIONAL_ARGUMENT ],
	[ '--password', '-p', GetoptLong::OPTIONAL_ARGUMENT ],
	[ '--john', '-j', GetoptLong::OPTIONAL_ARGUMENT],
	[ '--format', '-f', GetoptLong::OPTIONAL_ARGUMENT]
)


opts.each do |opt, arg|
	case opt
	when '--help'
		help
	when '--host'
		host = arg
	when '--port'
		port = arg.to_i
	when '--password'
		passwd = Digest::MD5.hexdigest(arg)
	when '--john'
		johnpath = arg
	when '--format'
		tformat = arg
	end
end


# Test if 'johpath' is valid
if !File.exist?(johnpath) or !File.executable_real?(johnpath)
	puts "#{johnpath} doesn't exist or is not executable."
	exit
end

if tformat != nil
	format = tformat.gsub(/[^a-zA-Z0-9\-]/, '')
end

john = Array.new	# john output
http = HttpPost.new	# http class
response = Hash.new	# http request information
$filename = nil		# password file
response['id'] = 0	# new client have id 0
passwdList = Array.new	# password to crack


# if client exist remove, myjohn session file
def	cleantmpfile

	begin
		if File.exist?($filename)
			File.delete($filename)
		end
		if File.exist?("#{$id}.log")
			File.delete("#{$id}.log")
		end
		if File.exist?("#{$id}.rec")
			File.delete("#{$id}.rec")
		end
	rescue
	
	end
end


# cleam tempory file before exit
trap "INT" do
	cleantmpfile	
	exit
end


# Request loop
begin

	# ask for new job
	server_response = http.NewJob(host, port, passwd, response['id'], method)
	passwdList.clear

	# parse server answer
	server_response.each_line do |line|
		key, value = line.split("=", 2)
		if value == nil
			puts "Server response : " + server_response.chomp
			exit		
		end
		if key == "p"
			passwdList.push(value.chomp)
		else
			response[key] = value.chomp
		end	
	end

	# exit if the password list is empty
	if passwdList.length == 0
		puts "[-] Error: #{server_response}"
		cleantmpfile		
		exit	
	end
	
	# variables initializations for john
	level = response['markov'].to_i
	start = response['start'].to_i
	mend = response['end'].to_i
	lenmax = response['lenmax'].to_i
	$id = response['id'].to_i

	# create password file
	$filename = "cli_passwd-" + $id.to_s
	file = File.open($filename, "w")
	file.write(passwdList.join("\n"));
	file.close

	puts "[+] New job, makov level:#{level.to_s} start:#{start.to_s} end:#{mend.to_s}"

	# if password range > 0
	if response['start'].to_i < response['end'].to_i
		johnarg = "#{johnpath} --markov=#{level.to_s}:#{start.to_s}:#{mend.to_s}:#{lenmax.to_s} --session=#{$id.to_s} #{$filename}"
		if format != nil
			johnarg = johnarg + " --format=#{format}"
		end
		johnarg = johnarg + " 2>/dev/null"
		out = `#{johnarg}`

		if $?.exitstatus != 0
			puts out
			cleantmpfile
			exit
		end

		# Parse john output
		out.each_line { |line| john.push line }
		if john.length > 3
			john[3 .. john.length - 1].each do |hash|
				puts "[+] Newhash: #{hash}"
				server_response = http.NewHash(host, port, passwd, response['id'], hash)		
			end		
		else
			puts "[-] No password found.\n"
		end
		john.clear
	else
		puts "[+] No work to do.\n"
	end

	cleantmpfile

end while passwdList.size > 0

cleantmpfile

